package betterquesting.commands.admin;

import betterquesting.api.properties.NativeProps;
import betterquesting.api.questing.IQuest;
import betterquesting.api2.storage.DBEntry;
import betterquesting.commands.QuestCommandBase;
import betterquesting.network.handlers.NetQuestEdit;
import betterquesting.questing.QuestDatabase;
import betterquesting.storage.NameCache;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import net.minecraft.command.CommandBase;
import net.minecraft.command.CommandException;
import net.minecraft.command.ICommandSender;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.ChatComponentTranslation;

/* loaded from: betterquesting_commands_admin.jar:betterquesting/commands/admin/QuestCommandComplete.class */
public class QuestCommandComplete extends QuestCommandBase {
    public String getUsageSuffix() {
        return "<quest_id> [username|uuid]";
    }

    public boolean validArgs(String[] args) {
        return args.length == 2 || args.length == 3;
    }

    public List<String> autoComplete(MinecraftServer server, ICommandSender sender, String[] args) {
        ArrayList<String> list = new ArrayList<>();
        if (args.length == 2) {
            for (DBEntry<IQuest> i : QuestDatabase.INSTANCE.getEntries()) {
                list.add("" + i.getID());
            }
        } else if (args.length == 3) {
            return CommandBase.func_71530_a(args, (String[]) NameCache.INSTANCE.getAllNames().toArray(new String[0]));
        }
        return list;
    }

    public String getCommand() {
        return "complete";
    }

    public void runCommand(MinecraftServer server, CommandBase command, ICommandSender sender, String[] args) throws CommandException {
        UUID uuid;
        if (args.length >= 3) {
            uuid = findPlayerID(server, sender, args[2]);
            if (uuid == null) {
                throw getException(command);
            }
        } else {
            uuid = findPlayerID(server, sender, sender.func_70005_c_());
        }
        String pName = uuid == null ? "NULL" : NameCache.INSTANCE.getName(uuid);
        int id = Integer.parseInt(args[1].trim());
        IQuest quest = (IQuest) QuestDatabase.INSTANCE.getValue(id);
        if (quest == null) {
            throw getException(command);
        }
        NetQuestEdit.setQuestStates(new int[]{id}, true, uuid);
        sender.func_145747_a(new ChatComponentTranslation("betterquesting.cmd.complete", new Object[]{new ChatComponentTranslation((String) quest.getProperty(NativeProps.NAME), new Object[0]), pName}));
    }

    public boolean isArgUsername(String[] args, int index) {
        return index == 2;
    }
}
